// generated from rosidl_generator_cpp/resource/msg__struct.hpp.em
// generated code does not contain a copyright notice

#ifndef NAV2_MSGS__MSG__TASK_STATUS__STRUCT_HPP_
#define NAV2_MSGS__MSG__TASK_STATUS__STRUCT_HPP_

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32) && defined(ERROR)
  #undef ERROR
#endif

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// include message dependencies

#ifndef _WIN32
# define DEPRECATED_nav2_msgs_msg_TaskStatus __attribute__((deprecated))
#else
# define DEPRECATED_nav2_msgs_msg_TaskStatus __declspec(deprecated)
#endif

namespace nav2_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct TaskStatus_
{
  using Type = TaskStatus_<ContainerAllocator>;

  explicit TaskStatus_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->result = 0;
    }
  }

  explicit TaskStatus_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_generator_cpp::MessageInitialization::ALL == _init ||
      rosidl_generator_cpp::MessageInitialization::ZERO == _init)
    {
      this->result = 0;
    }
  }

  // field types and members
  using _result_type =
    uint8_t;
  _result_type result;

  // setters for named parameter idiom
  Type * set__result(
    const uint8_t & _arg)
  {
    this->result = _arg;
    return this;
  }

  // constant declarations
  static constexpr uint8_t SUCCEEDED =
    0u;
  static constexpr uint8_t FAILED =
    1u;
  static constexpr uint8_t RUNNING =
    2u;
  static constexpr uint8_t CANCELED =
    3u;

  // pointer types
  using RawPtr =
    nav2_msgs::msg::TaskStatus_<ContainerAllocator> *;
  using ConstRawPtr =
    const nav2_msgs::msg::TaskStatus_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<nav2_msgs::msg::TaskStatus_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<nav2_msgs::msg::TaskStatus_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      nav2_msgs::msg::TaskStatus_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<nav2_msgs::msg::TaskStatus_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      nav2_msgs::msg::TaskStatus_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<nav2_msgs::msg::TaskStatus_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<nav2_msgs::msg::TaskStatus_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<nav2_msgs::msg::TaskStatus_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED_nav2_msgs_msg_TaskStatus
    std::shared_ptr<nav2_msgs::msg::TaskStatus_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED_nav2_msgs_msg_TaskStatus
    std::shared_ptr<nav2_msgs::msg::TaskStatus_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TaskStatus_ & other) const
  {
    if (this->result != other.result) {
      return false;
    }
    return true;
  }
  bool operator!=(const TaskStatus_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TaskStatus_

// alias to use template instance with default allocator
using TaskStatus =
  nav2_msgs::msg::TaskStatus_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr uint8_t TaskStatus_<ContainerAllocator>::SUCCEEDED;
template<typename ContainerAllocator>
constexpr uint8_t TaskStatus_<ContainerAllocator>::FAILED;
template<typename ContainerAllocator>
constexpr uint8_t TaskStatus_<ContainerAllocator>::RUNNING;
template<typename ContainerAllocator>
constexpr uint8_t TaskStatus_<ContainerAllocator>::CANCELED;

}  // namespace msg

}  // namespace nav2_msgs

#endif  // NAV2_MSGS__MSG__TASK_STATUS__STRUCT_HPP_
