// generated from rosidl_generator_cpp/resource/msg__struct.hpp.em
// generated code does not contain a copyright notice

#ifndef NAV2_MSGS__SRV__GET_COSTMAP__REQUEST__STRUCT_HPP_
#define NAV2_MSGS__SRV__GET_COSTMAP__REQUEST__STRUCT_HPP_

// Protect against ERROR being predefined on Windows, in case somebody defines a
// constant by that name.
#if defined(_WIN32) && defined(ERROR)
  #undef ERROR
#endif

#include <rosidl_generator_cpp/bounded_vector.hpp>
#include <rosidl_generator_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

// include message dependencies
#include "nav2_msgs/msg/costmap_meta_data.hpp"  // specs

#ifndef _WIN32
# define DEPRECATED_nav2_msgs_srv_GetCostmap_Request __attribute__((deprecated))
#else
# define DEPRECATED_nav2_msgs_srv_GetCostmap_Request __declspec(deprecated)
#endif

namespace nav2_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetCostmap_Request_
{
  using Type = GetCostmap_Request_<ContainerAllocator>;

  explicit GetCostmap_Request_(rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : specs(_init)
  {
    (void)_init;
  }

  explicit GetCostmap_Request_(const ContainerAllocator & _alloc, rosidl_generator_cpp::MessageInitialization _init = rosidl_generator_cpp::MessageInitialization::ALL)
  : specs(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _specs_type =
    nav2_msgs::msg::CostmapMetaData_<ContainerAllocator>;
  _specs_type specs;

  // setters for named parameter idiom
  Type * set__specs(
    const nav2_msgs::msg::CostmapMetaData_<ContainerAllocator> & _arg)
  {
    this->specs = _arg;
    return this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    nav2_msgs::srv::GetCostmap_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const nav2_msgs::srv::GetCostmap_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<nav2_msgs::srv::GetCostmap_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<nav2_msgs::srv::GetCostmap_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      nav2_msgs::srv::GetCostmap_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<nav2_msgs::srv::GetCostmap_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      nav2_msgs::srv::GetCostmap_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<nav2_msgs::srv::GetCostmap_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<nav2_msgs::srv::GetCostmap_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<nav2_msgs::srv::GetCostmap_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED_nav2_msgs_srv_GetCostmap_Request
    std::shared_ptr<nav2_msgs::srv::GetCostmap_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED_nav2_msgs_srv_GetCostmap_Request
    std::shared_ptr<nav2_msgs::srv::GetCostmap_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetCostmap_Request_ & other) const
  {
    if (this->specs != other.specs) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetCostmap_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetCostmap_Request_

// alias to use template instance with default allocator
using GetCostmap_Request =
  nav2_msgs::srv::GetCostmap_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace nav2_msgs

#endif  // NAV2_MSGS__SRV__GET_COSTMAP__REQUEST__STRUCT_HPP_
